' cdiffed.VBS V2.00 (C) yoshioka.teruo@nifty.com, 2003-10-06.
' cdiffed.VBS postprocesses output of diff
' Usage: cscript //nologo cdiffed.vbs <input >output

Option Explicit

Dim NFL
Dim COL
Dim NFC
Dim tabStop

NFL=5
COL=80
NFC="@"
tabStop=8

' Variables For TwoUp
Dim lspace
Dim cspace
Dim lmark
Dim rmark
Dim smark
Dim emark

lspace="  "
cspace="  "
lmark="| "
rmark=" |"
smark="+-" & String(NFL+COL+2+NFL+COL,"-") & "-+"
emark=smark

Dim flag
Dim lcount
Dim rcount
Dim mcount
Dim rcode(100)
Dim lcode(100)
Dim lnumber
Dim rnumber
Dim lline
Dim rline
Dim stdout

Set stdout=WScript.StdOut

flag=0
lcount=0
rcount=0

WScript.Quit Expand()

Function Expand()
  Dim stdin
  Set stdin=WScript.StdIn

  Do While Not stdin.AtEndOfStream
    Dim line
    Dim columns
    Dim str
    Dim n

    line=stdin.ReadLine
    columns=0
    str=Left(line,NFL)
    For n=NFL+1 To Len(line)
      Dim char
      Dim m

      char=Mid(line,n,1)
      If char=vbTAB Then
        m=tabStop-(columns Mod tabStop)
        str=str & Space(m)
        columns=columns+m
      Else
        str=str & char
        columns=columns+WideCharLen(char)
      End If
    Next
    Fold str
  Loop
End Function

Sub Fold(line)
  Dim columns
  Dim n

  columns=0
  n=1
  Do While n<=Len(line)
    Dim char
    char=Mid(line,n,1)
    columns=columns+WideCharLen(char)
    If columns>NFL+COL Then
      TwoUp Left(line,n-1)
      line=Space(NFL) & Mid(line,n)
      n=1
      columns=WideCharLen(char)
    End If
    n=n+1
  Loop
  TwoUp line
End Sub

Sub TwoUp(line)
' flag = 0:common 1:left/old 2:right/new
  If Left(line,7)="#ifndef" Then
    flag=1
  ElseIf Left(line,6)="#ifdef" Then
    flag=2
  ElseIf Left(line,5)="#else" Then
    flag=2
  ElseIf Left(line,6)="#endif" Then
    Dim i

    stdout.WriteLine smark
    If lcount>rcount Then
      mcount=lcount
    Else
      mcount=rcount
    End If
    For i=0 To mcount-1
      line=lmark
      If i<lcount Then
        If Left(lcode(i),NFL)=String(NFL,NFC) Then
          lnumber=lnumber+1
          lcode(i)=Right(String(NFL,"0") & lnumber & " ",NFL) & Mid(lcode(i),NFL+1)
        End If
        line=line & lcode(i) & Space(NFL+COL-Length(lcode(i)))
      Else
        line=line & Space(NFL+COL)
      End If
      line=line & cspace
      If i<rcount Then
        If Left(rcode(i),NFL)=String(NFL,NFC) Then
          rnumber=rnumber+1
          rcode(i)=Right(String(NFL,"0") & rnumber & " ",NFL) & Mid(rcode(i),NFL+1)
        End If
        line=line & rcode(i) & Space(NFL+COL-Length(rcode(i)))
      Else
        line=line & Space(NFL+COL)
      End If
      line=line & rmark
      stdout.WriteLine line
    Next
    stdout.WriteLine emark
    flag=0
    lcount=0
    rcount=0
  ElseIf flag=1 Then
    lcode(lcount)=line
    lcount=lcount+1
  ElseIf flag=2 Then
    rcode(rcount)=line
    rcount=rcount+1
  Else
    If Left(line,NFL)=String(NFL,NFC) Then
      lnumber=lnumber+1
      lline=Right(String(NFL,"0") & lnumber & " ",NFL) & Mid(line,NFL+1)
      rnumber=rnumber+1
      rline=Right(String(NFL,"0") & rnumber & " ",NFL) & Mid(line,NFL+1)
      stdout.WriteLine lspace & lline & Space(NFL+COL-Length(line)) & cspace & rline
    Else
      stdout.WriteLine lspace & line & Space(NFL+COL-Length(line)) & cspace & line
    End If
  End If
End Sub

Function Length(str)
  Dim n
  For n=1 To Len(str)
    Length=Length+WideCharLen(Mid(str,n,1))
  Next
End Function

Function WideCharLen(char)
  If Asc(char)<0 Then
    WideCharLen=2
  Else
    WideCharLen=1
  End If
End Function

