' cdiffsum.VBS V2.00 (C) yoshioka.teruo@nifty.com, 2003-10-06.
' cdiffsum.VBS summarise cdiff output
' Usage: cscript //nologo cdiffsum.vbs [-p] <input >output

Option Explicit
Dim PageLines
Dim P

PageLines=66
P=False

If WScript.Arguments.Count>0 Then
  P=True
End If

WScript.Quit Main()

Function Main()
Dim stdin
Dim stdout
Dim lineCount
Dim pageCount
Dim page(1000)
Dim lines(100)
Dim n
Dim pages
Dim change

Set stdin=WScript.StdIn
Set stdout=WScript.StdOut

lineCount=0
pageCount=1
Do While Not stdin.AtEndOfStream
  Dim line

  line=stdin.ReadLine
  lineCount=lineCount+1
  If lineCount>PageLines Then
    If P And page(pageCount)>0 Then
      For n=1 To PageLines
        stdout.WriteLine lines(n)
      Next
    End If
    pageCount=pageCount+1
    lineCount=1
    change=False
  End IF
  lines(lineCount)=line
  If Left(line,2)<>Space(2) Then
    If Not change Then
      page(pageCount)=page(pageCount)+1
      change=True
    End If
  Else
    change=False
  End If
Loop

If P And page(pageCount)>0 Then
  For n=1 To lineCount
    stdout.WriteLine lines(n)
  Next
  stdout.WriteBlankLines(PageLines-lineCount)
End If

pages=0
change=0
For n=1 To pageCount
  If page(n)>0 Then
    pages=pages+1
    change=change+page(n)
    stdout.WriteLine "Page : " & n & " ( " & page(n) & " ) "
  End If
Next
stdout.WriteLine "Total : " & pages & " / " & pageCount & " ( " & change  & " ) "

End Function

